unit dllInterface;


interface
uses
 Windows;

const
  MaxPolyDegree = 20;    { maximum number of polynomial degree }

type
  T1DRealArray = array of double;

  pFrameArrayRecord = ^TFrameArrayRecord;
  TFrameArrayRecord = record
    CCDData     : array of double;
    CalibData   : array of double;
    AbsIntenData: array of double;
  end;//
  
  tPolyDegree = 1..MaxPolyDegree;
  TDegreeVector = Array[1..MaxPolyDegree] of Double;

  PFrameDataProperty = ^TFrameDataProperty;
  TFrameDataProperty = record
    CameraID : integer;
    ExposureTime : integer;
    TimeStamp : integer;
    TriggerOccurred : integer;
    TriggerEventCount: integer;
    OverSaturated: integer;
    LightShieldAverageValue : integer;
  end;


  TLinearCameraSpectrometerFrameCallBack = procedure(Row:integer; Col:integer;
                                                     ImageProperty :PFrameDataProperty ;
                                                     FramePtr:array of Pdouble); cdecl;

  TUSBDeviceCallBack = procedure( DeviceType: integer ); cdecl;

function MTSSE_InstallMsgHooker(MsgHooker:TFarProc):integer;cdecl;
function MTSSE_InitDevice( Handle : Thandle ):integer;cdecl;
function MTSSE_InstallUSBDeviceHooker( USBDeviceHooker : TUSBDeviceCallBack ): integer;  cdecl;
function MTSSE_InstallDeviceFrameHooker(const deviceNo: integer;
                                        DeviceHookerProc: TLinearCameraSpectrometerFrameCallBack ):integer;cdecl;

function MTSSE_StartFrameGrab(const GrabType : integer = 1 ):integer;cdecl;
function MTSSE_StopFrameGrab(): integer ; cdecl;
function MTSSE_UnInitDevice():integer;cdecl;
function MTSSE_GetDeviceModuleNoSerialNo(const DeviceNo:integer;
                                         ModuleNo:PAnsiChar;
                                         SerialNo:PAnsiChar ):integer;cdecl;
function MTSSE_GetDeviceProperty( const DeviceNo:integer;
                                  ptr:PInteger ):integer;cdecl;                                         
function MTSSE_SetDeviceActiveStatus( const deviceNo:integer;
                                      const ActiveStatus:integer ):integer;cdecl;
function MTSSE_SetDeviceAverageFrameNum( const DeviceNo:integer;
                                         const AvgFrameNum:integer):integer;cdecl;
function MTSSE_SetDeviceWorkMode( const DeviceNo : integer;
                                  const WorkMode : integer ):integer;cdecl;
function MTSSE_SetDeviceExposureTime(const DeviceNo:integer;
                                     const ExpTime:integer):integer;cdecl;
function MTSSE_SetDeviceGPIOConfig(DeviceNo:integer;Config:integer):integer;cdecl;
function MTSSE_SetDeviceGPIOInOut(DeviceNo:integer;Output:integer; Input:PByte):integer;cdecl;
function MTSSE_GetDeviceSpectrometerWavCalPara(const DeviceNo : integer;
                                               const SpectroNo : integer;
                                               var ptr : PDouble) : integer;cdecl;
function MTSSE_SetDeviceSpectrometerAutoDarkStatus( const DeviceNo : integer ;
                                                    const SpectroNo : integer;
                                                    const Status : integer ):integer;cdecl;
function MTSSE_SetDeviceSpectrometerETCStatus(const DeviceNo:integer;
                                              const SpectroNo : integer;
                                              const Status:integer):integer;cdecl;
function MTSSE_SetDeviceSpectrometerDarkData(const DeviceNo : integer;
                                             const SpectroNo : integer;
                                             ptrData : pDouble ):integer;cdecl;
function MTSSE_GetDeviceSpectrometerFrameData( const DeviceNo :integer;
                                               const SpectroNo : Integer;
                                               const WaitUntilDone : Integer;
                                               var PtrData:PDouble) : Integer;cdecl;
function MTSSE_GetDeviceSpectrometerFrameDataProperty( const DeviceNo :integer;
                                               const SpectroNo : Integer;
                                               const WaitUntilDone : Integer;
                                               ptrFrameProperty: PFrameDataProperty;
                                               var PtrData : PDouble):Integer;cdecl;
                                                                                              
function MTSSE_SaveDeviceSpectrometerWavCalPara(const DeviceNo : Integer;
                                                const SpectroNo : Integer;
                                                const ptr:PDouble ):integer;cdecl;
function MTSSE_GetDeviceSpectrometerCIE1931Coords( const DeviceNo:integer;
                                                   const SpectroID:integer;
                                                   const ptrData:pDouble;
                                                   var x:Double;
                                                   var y:Double):integer;cdecl;
function MTSSE_GetDeviceSpectrometerCIE1976Coords( const DeviceNo:integer;
                                                   const SpectroID:integer;
                                                   ptrData:pDouble;
                                                   var x:Double;
                                                   var y:Double):integer;cdecl;
function MTSSE_GetDeviceSpectrometerCCT( const DeviceNo:integer;
                                         const SpectroID:integer;
                                         const ptrData:pDouble;
                                         var CCT:integer):integer;cdecl;

function MTSSE_GetDeviceSpectrometerCRIs( const DeviceNo:integer;
                                          const SpectroID:integer;
                                          const ptrData:pDouble;
                                          ptrCRIs : PDouble):integer;cdecl;
implementation

  //Sys Call
 function MTSSE_InstallMsgHooker;external 'MT_Spectrometer_SDK.dll' name 'MTSSE_InstallMsgHooker';
 function MTSSE_InitDevice;external 'MT_Spectrometer_SDK.dll' name 'MTSSE_InitDevice';
 function MTSSE_InstallUSBDeviceHooker;external 'MT_Spectrometer_SDK.dll' name 'MTSSE_InstallUSBDeviceHooker';
 function MTSSE_InstallDeviceFrameHooker;external 'MT_Spectrometer_SDK.dll' name 'MTSSE_InstallDeviceFrameHooker';
 function MTSSE_StartFrameGrab;external 'MT_Spectrometer_SDK.dll' name 'MTSSE_StartFrameGrab';
 function MTSSE_StopFrameGrab;external 'MT_Spectrometer_SDK.dll' name 'MTSSE_StopFrameGrab';
 function MTSSE_UnInitDevice;external 'MT_Spectrometer_SDK.dll' name 'MTSSE_UnInitDevice';

 //------------------------------------
  // Device Getter and setter
  //-----------------------------
  // Getter
  //-----------------------------
 function MTSSE_GetDeviceModuleNoSerialNo;external 'MT_Spectrometer_SDK.dll' name 'MTSSE_GetDeviceModuleNoSerialNo';
 function MTSSE_GetDeviceSpectrometerWavCalPara;external 'MT_Spectrometer_SDK.dll' name 'MTSSE_GetDeviceSpectrometerWavCalPara';
  //---------------------
  // Setter
  //---------------------
 function MTSSE_SetDeviceActiveStatus;external 'MT_Spectrometer_SDK.dll' name 'MTSSE_SetDeviceActiveStatus';
 function MTSSE_SetDeviceAverageFrameNum;external 'MT_Spectrometer_SDK.dll' name 'MTSSE_SetDeviceAverageFrameNum';
 function MTSSE_SetDeviceWorkMode;external 'MT_Spectrometer_SDK.dll' name 'MTSSE_SetDeviceWorkMode';
 function MTSSE_SetDeviceExposureTime;external 'MT_Spectrometer_SDK.dll' name 'MTSSE_SetDeviceExposureTime';
 function MTSSE_SetDeviceGPIOConfig;external 'MT_Spectrometer_SDK.dll' name 'MTSSE_SetDeviceGPIOConfig';
 function MTSSE_SetDeviceGPIOInOut;external 'MT_Spectrometer_SDK.dll' name 'MTSSE_SetDeviceGPIOInOut';
 function MTSSE_GetDeviceProperty;external 'MT_Spectrometer_SDK.dll' name 'MTSSE_GetDeviceProperty';
 function MTSSE_SetDeviceSpectrometerAutoDarkStatus;external 'MT_Spectrometer_SDK.dll' name 'MTSSE_SetDeviceSpectrometerAutoDarkStatus';
 function MTSSE_SetDeviceSpectrometerETCStatus;external 'MT_Spectrometer_SDK.dll' name 'MTSSE_SetDeviceSpectrometerETCStatus';
 function MTSSE_SetDeviceSpectrometerDarkData;external 'MT_Spectrometer_SDK.dll' name 'MTSSE_SetDeviceSpectrometerDarkData';
 function MTSSE_SaveDeviceSpectrometerWavCalPara;external 'MT_Spectrometer_SDK.dll' name 'MTSSE_SaveDeviceSpectrometerWavCalPara';
  //Pure Function Call
 function MTSSE_GetDeviceSpectrometerFrameData;external 'MT_Spectrometer_SDK.dll' name 'MTSSE_GetDeviceSpectrometerFrameData';
 function MTSSE_GetDeviceSpectrometerFrameDataProperty;external 'MT_Spectrometer_SDK.dll' name 'MTSSE_GetDeviceSpectrometerFrameDataProperty';
 function MTSSE_GetDeviceSpectrometerCIE1931Coords;external 'MT_Spectrometer_SDK.dll' name 'MTSSE_GetDeviceSpectrometerCIE1931Coords';
 function MTSSE_GetDeviceSpectrometerCIE1976Coords;external 'MT_Spectrometer_SDK.dll' name 'MTSSE_GetDeviceSpectrometerCIE1976Coords';
 function MTSSE_GetDeviceSpectrometerCCT;external 'MT_Spectrometer_SDK.dll' name 'MTSSE_GetDeviceSpectrometerCCT';
 function MTSSE_GetDeviceSpectrometerCRIs;external 'MT_Spectrometer_SDK.dll' name 'MTSSE_GetDeviceSpectrometerCRIs';
end.
