unit main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ExtCtrls,dllInterface, TeEngine, Series,
  TeeProcs, Chart;

type
  TMainForm = class(TForm)
    Statusbar: TStatusBar;
    Panel1: TPanel;
    BtnUnInit: TButton;
    BtnInitDevice: TButton;
    LabelInitDevice: TLabel;
    BtnStartGrab: TButton;
    BtnStopGrab: TButton;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    BtnSetGPIOInOut: TButton;
    EditGPIOInOut: TEdit;
    EditGPIOConfig: TEdit;
    BtnSetGPIOConfig: TButton;
    BtnSetExpTime: TButton;
    EditExpTime: TEdit;
    RadioWorkMode: TRadioGroup;
    BtnSetWorkMode: TButton;
    BtnSetAvgNum: TButton;
    EditAvgNum: TEdit;
    Label2: TLabel;
    BtnGetModuleNo: TButton;
    LabelModuleNo: TLabel;
    BtnSetActiveStatus: TButton;
    CheckActiveFlag: TCheckBox;
    LabelGPIOIn: TLabel;
    GroupBox2: TGroupBox;
    GroupBox3: TGroupBox;
    LabelWavCalA0: TLabel;
    BtnGetSpectroWavCal: TButton;
    GroupBox4: TGroupBox;
    GroupBox5: TGroupBox;
    AutoDarkFlag: TCheckBox;
    BtnSetAutoDrk: TButton;
    LabelWavCalA1: TLabel;
    LabelWavCalA2: TLabel;
    LabelWavCalA3: TLabel;
    GroupBox8: TGroupBox;
    CheckETCFlag: TCheckBox;
    BtnSetETCFlag: TButton;
    Chart1: TChart;
    Series1: TFastLineSeries;
    BtnSetDrkData: TButton;
    Btnxy: TButton;
    btnUV: TButton;
    btnCCT: TButton;
    btnCRI: TButton;
    Labelxy: TLabel;
    Labeluv: TLabel;
    labelcct: TLabel;
    LabelCRIa: TLabel;
    GroupBox6: TGroupBox;
    BtnInstallFrameHooker: TButton;
    BtnGetFrameData: TButton;
    CheckBoxWaitFlag: TCheckBox;
    RadioGroupGrabType: TRadioGroup;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    Timer1: TTimer;

    procedure BtnInitDeviceClick(Sender: TObject);
    procedure BtnInstallDeviceHookerClick(Sender: TObject);
    procedure BtnStartGrabClick(Sender: TObject);
    procedure BtnInstallFrameHookerClick(Sender: TObject);
    procedure BtnStopGrabClick(Sender: TObject);
    procedure BtnUnInitClick(Sender: TObject);
    procedure BtnGetModuleNoClick(Sender: TObject);

    procedure BtnSetActiveStatusClick(Sender: TObject);

    procedure BtnSetAvgNumClick(Sender: TObject);
    procedure BtnSetWorkModeClick(Sender: TObject);
    procedure BtnSetExpTimeClick(Sender: TObject);


    procedure BtnSetGPIOConfigClick(Sender: TObject);
    procedure BtnSetGPIOInOutClick(Sender: TObject);

    procedure BtnGetSpectroWavCalClick(Sender: TObject);
    procedure BtnSetAutoDrkClick(Sender: TObject);
    procedure BtnSetETCFlagClick(Sender: TObject);
    procedure BtnGetFrameDataClick(Sender: TObject);
    procedure BtnSetDrkDataClick(Sender: TObject);
    procedure BtnxyClick(Sender: TObject);
    procedure btnUVClick(Sender: TObject);
    procedure btnCCTClick(Sender: TObject);
    procedure btnCRIClick(Sender: TObject);
    procedure RadioGroupGrabTypeClick(Sender: TObject);
    procedure RadioButton2Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
  end;
type
  pFrameRecord = ^TFrameRecord;
  TFrameRecord = record
    CCDData     : array[0..3647] of double;
    CalibData   : array[0..3647] of double;
    AbsIntenData: array[0..3647] of double;
  end;//
var
  MainForm: TMainForm;
  DeviceID : Integer =  1;
  SpectroID : Integer =  1;
  MaxPixelNumber : Integer = 0;
  Framerecord : TFrameRecord;//  TFrameRecord
  bUpdateChart : Boolean;
implementation


{$R *.dfm}

procedure USBDeviceHooker( DeviceType: integer );cdecl;
begin
//  MainForm.LabelUSBHookerEvent.Caption := IntToStr( DeviceType )
//                                                + 'DeviceCommError';
end;

procedure FrameCallBack(Row:integer; Col:integer;
                        ImageProperty :PFrameDataProperty ;
                        FramePtr:array of Pdouble); cdecl;
var
  I: Integer;
begin
  if ImageProperty^.CameraID = DeviceID then
    begin
      if FramePtr[0] <> nil then
        begin
          for I := 0 to 3647 do    // Iterate
          begin
            Framerecord.CCDData[i]:=(PFrameArrayRecord(FramePtr[0]))^.CCDData[i];
            Framerecord.CalibData[i] :=
                        (PFrameArrayRecord(FramePtr[0]))^.CalibData[i];

            Framerecord.AbsIntenData[i] :=
                        (pFrameArrayRecord(FramePtr[0]))^.AbsIntenData[i];
          end;    // for
          if bUpdateChart = true then
            begin
              MainForm.Series1.Clear;
              for I := 0 to 3647 do    // Iterate
                MainForm.Series1.AddXY( i, Framerecord.AbsIntenData[i]);

              bUpdateChart := false;
            end;
        end;
      MainForm.StatusBar.Panels[0].Text := IntToStr(ImageProperty^.TimeStamp)
                                      + ','
                                      + IntToStr(ImageProperty^.ExposureTime);
    end;
end;


procedure TMainForm.BtnInitDeviceClick(Sender: TObject);
var
  Flag : Integer;
  I : Integer;
begin
  flag :=MTSSE_InitDevice( MainForm.Handle );
  LabelInitDevice.Caption := IntToStr(Flag);
  StatusBar.Panels[0].Text := 'InitDevice,' + IntToStr(Flag);
  if flag > 0 then
    begin
      DeviceID := 1;
      SpectroID := 1;
    end
  else
    begin
      DeviceID := 0;
      SpectroID := 0;
    end;
end;

procedure TMainForm.BtnInstallDeviceHookerClick(Sender: TObject);
var
  flag : Integer;
begin
  Flag := MTSSE_InstallUSBDeviceHooker( USBDeviceHooker );
  StatusBar.Panels[0].Text := 'SetUSBDeviceHooker,' + IntToStr(Flag);
end;

procedure TMainForm.BtnStartGrabClick(Sender: TObject);
var
  GrabType: Integer;
  flag : Integer;
begin
  case self.RadioGroupGrabType.ItemIndex of    //
    0: GrabType := $8888;
    1: GrabType := 1;
  end;    // case

  flag := MTSSE_StartFrameGrab( GrabType );
  StatusBar.Panels[0].Text := 'Start Grab '
                              + IntToStr(GrabType) + ',' + IntTostr(Flag);
end;

procedure TMainForm.BtnStopGrabClick(Sender: TObject);
var
  flag : integer;
begin
  flag :=  MTSSE_StopFrameGrab();

  StatusBar.Panels[0].Text := 'Stop Grab, ' + IntToStr(Flag) ;
end;

procedure TMainForm.BtnUnInitClick(Sender: TObject);
var
  flag : Integer;
begin
  flag := MTSSE_UnInitDevice();

  Statusbar.Panels[0].Text := 'UninitDevice, ' + IntToStr(Flag);
end;

procedure TMainForm.BtnInstallFrameHookerClick(Sender: TObject);
var
  flag : Integer;
begin
  flag := MTSSE_InstallDeviceFrameHooker( DeviceID , FrameCallBack);

  StatusBar.Panels[0].Text := 'Install Device Frame Hooker, ' + IntToStr( flag );
end;

procedure TMainForm.BtnGetModuleNoClick(Sender: TObject);
var
  ModuleNo, SerialNo: Array[0..15] of AnsiChar;
  flag : Integer;
begin
  flag := MTSSE_GetDeviceModuleNoSerialNo( DeviceId, ModuleNO, SerialNo);
  if flag <> - 1 then
    begin
      LabelModuleNo.Caption := Trim(AnsiString(ModuleNo)) + '_'
                             + Trim(AnsiString(SerialNo)) ;
    end;

  StatusBar.Panels[0].Text := 'Get DeviceModuleNoSerialNo, ' + IntTosTr(Flag);
end;

procedure TMainForm.BtnSetActiveStatusClick(Sender: TObject);
var
  Flag: Integer;
  Status: integer;
begin
  Status := Integer( self.CheckActiveFlag.Checked );
  flag := MTSSE_SetDeviceActiveStatus( DeviceID, status);
  StatusBar.Panels[0].Text := 'Set Active Status, ' + IntTosTr(Flag);
end;

procedure TMainForm.BtnSetAvgNumClick(Sender: TObject);
var
  Flag: Integer;
  AvgNum : integer;
begin
  try
  AvgNum := StrToInt (self.EditAvgNum.text);
  except
    on e:EConvertError do
      Application.HandleException(Sender);
  end;

  Flag := MTSSE_SetDeviceAverageFrameNum( DeviceID, AvgNum);
  StatusBar.Panels[0].Text := 'Set Average Frame Number, ' + IntTosTr(Flag);
end;

procedure TMainForm.BtnSetWorkModeClick(Sender: TObject);
var
  Flag: Integer;
  WorkMode : Integer;
begin
  WorkMode := self.RadioWorkMode.ItemIndex;
  flag := MTSSE_SetDeviceWorkMode( DeviceID ,WorkMode );
  StatusBar.Panels[0].Text := 'Set WorkMode, ' + IntTosTr(Flag);
end;

procedure TMainForm.BtnSetExpTimeClick(Sender: TObject);
var
  Flag: Integer;
  ExpTime : Integer;
begin
  try
    ExpTime := StrToInt(Self.EditExpTime.Text);
  except
    on e:EConvertError do
      Application.HandleException(Sender);
  end;
  flag := MTSSE_SetDeviceExposureTime(DeviceID, ExpTime);
  StatusBar.Panels[0].Text :=' Set Exposure Time, '  + IntTosTr(Flag);
end;




procedure TMainForm.BtnSetGPIOConfigClick(Sender: TObject);
var
  Flag: Integer;
  Config : Integer;
begin
  try
    Config := StrToInt( self.EditGPIOConfig.Text );
  except
    on e: EConvertError do
      Application.HandleException(Sender);
  end;
  flag := MTSSE_SetDeviceGPIOConfig( DeviceID, Config);
  StatusBar.Panels[0].Text := 'Set GPIO Config, '  + IntTosTr(Flag);

end;

procedure TMainForm.BtnSetGPIOInOutClick(Sender: TObject);
var
  Flag: Integer;
  Intput : Byte;
  Output: Integer;
begin
  try
    Output := StrToInt( self.EditGPIOInOut.Text );
  except
    on e: EConvertError do
      Application.HandleException(Sender);
  end;
  flag := MTSSE_SetDeviceGPIOInOut( DEviceID, Output, @Intput );
  if  flag = 1 then
    LabelGPIOIn.Caption := 'GPIOIn:' + IntToStr(Intput);
    
end;

procedure TMainForm.BtnGetSpectroWavCalClick(Sender: TObject);
var
  Flag: Integer;
  ptr: PDouble;
begin
  //ptr[0-3]: A0 - A3
  //ptr[4-7]: B0 - B3
  flag := MTSSE_GetDeviceSpectrometerWavCalPara( DeviceID, SpectroID, ptr);
  if ptr <> nil then
    begin
      LabelWavCalA0.Caption := FloatToStr( ptr^ );
      Inc(ptr);
      LabelWavCalA1.Caption := FloatToStr( ptr^ );
      Inc(ptr);
      LabelWavCalA2.Caption := FloatToStr( ptr^ );
      Inc(ptr);
      LabelWavCalA3.Caption := FloatToStr( ptr^ );
      //Inc(ptr);
      //LabelWavCal.Caption := FloatToStr( ptr^ );
    end
  else
    LabelWavCalA0.Caption := 'WavCalibPara NotFount';
  StatusBar.Panels[0].Text := 'Get Wav CalPara' + IntTosTr(Flag);
end;

procedure TMainForm.BtnSetAutoDrkClick(Sender: TObject);
var
  Flag: Integer;
  status: Integer;
begin
  Status:= Integer(self.AutoDarkFlag.Checked );
  Flag := MTSSE_SetDeviceSpectrometerAutoDarkStatus(DeviceID,SpectroID,status);
  StatusBar.Panels[0].Text := 'Set Auto Dark Status, ' + IntTosTr(Flag);
end;

procedure TMainForm.BtnSetETCFlagClick(Sender: TObject);
var
  Flag: Integer;
  Status : Integer;
begin
  Status := Integer(self.CheckETCFlag.Checked );
  Flag := MTSSE_SetDeviceSpectrometerETCStatus(DeviceID, SpectroID, status);
  StatusBar.Panels[0].Text := 'Set ETC Status, ' + IntTosTr(Flag);
end;

procedure TMainForm.BtnGetFrameDataClick(Sender: TObject);
var
  I: Integer;
  Flag: Integer;
  ptrfloat : pDouble;
  WaitFlag: Integer;
  FrameProperty :TFrameDataProperty;
//  ptrFrameProperty: PFrameDataProperty;
begin
  flag := MTSSE_InstallDeviceFrameHooker( DeviceID , nil );
  WaitFlag := Integer( checkboxWaitFlag.Checked );
  //flag := MTSSE_GetDeviceSpectrometerFrameData(DeviceID,SpectroID,WaitFlag,ptrFloat);
  //ptrFrameProperty := @FrameProperty;
  flag := MTSSE_GetDeviceSpectrometerFrameDataProperty(DeviceID,SpectroID,WaitFlag,@FrameProperty,ptrFloat);
  if ptrFloat <> nil then
    begin
      Series1.Clear;
      for I := 0 to Length(Framerecord.CCDData) - 1 do    // Iterate
      begin
        Framerecord.CCDData[i] := pFrameArrayRecord( ptrFloat).CCDData[i] ;
        Framerecord.CalibData[i]
                              := pFrameArrayRecord( ptrFloat).CalibData[i];
        Framerecord.AbsIntenData[i]
                              :=  pFrameArrayRecord( ptrFloat).AbsIntenData[i];
        series1.AddXY(i, Framerecord.AbsIntenData[i]);
      end;    // for
    end;
  StatusBar.Panels[0].Text := 'Get FrameData, ' + IntTosTr(Flag);

end;

procedure TMainForm.BtnSetDrkDataClick(Sender: TObject);
var
  Flag: Integer;
  DrkData : array[0..3647] of double;
  I : Integer;
begin
//  for I := 0 to 3647 do    // Iterate
//  begin
//    DrkData[i] := Random( 300 );
//  end;    // for

//  flag := MTSSE_SetDeviceSpectrometerDarkData(DeviceID,spectroID, @DrkData[0]);
  flag := MTSSE_SetDeviceSpectrometerDarkData(DeviceID,spectroID,
                                               @(Framerecord.CalibData[0]));
  StatusBar.Panels[0].Text := 'Set Dark Data, ' + IntTosTr(Flag);
end;

procedure TMainForm.BtnxyClick(Sender: TObject);
var
  tmpFlag : Integer;
  x, y : double;
begin

  tmpFlag := MTSSE_GetDeviceSpectrometerCIE1931Coords(DeviceID, SpectroID,
                                        @(Framerecord.AbsIntenData[0]), x, y);
  if tmpFlag = 1 then
    begin
      Labelxy.Caption := floatTostr(x) + ';' + floatToStr(Y);
    end;
end;

procedure TMainForm.btnUVClick(Sender: TObject);
var
  tmpFlag : Integer;
  up,vp : double;
begin
  tmpFlag := MTSSE_GetDeviceSpectrometerCIE1976Coords(DeviceID, SpectroID,
                                        @(Framerecord.AbsIntenData[0]),up,vp);
  if tmpFlag = 1 then
    begin
      Labeluv.Caption := floatToStr(up) + ';' +floatTostr(vp);
    end;
end;

procedure TMainForm.btnCCTClick(Sender: TObject);
var
  tmpFlag : Integer;
  CCT : Integer;
begin
  tmpFlag :=MTSSE_GetDeviceSpectrometerCCT(DeviceID, SpectroID,
                                        @(Framerecord.AbsIntenData[0]),CCT);
  if tmpFlag = 1 then
    begin
      LabelCCT.Caption := IntTostr( CCT );
    end;
end;

procedure TMainForm.btnCRIClick(Sender: TObject);
var
  tmpFlag : Integer;
  CRIs : array[0..14] of double;//CRIs[0] - CRIa, CRI_1..14
begin
  tmpFlag := MTSSE_GetDeviceSpectrometerCRIs(DeviceID, SpectroID,
                                        @(Framerecord.AbsIntenData[0]),@CRIs);
  if tmpFlag = 1 then
    begin
      LabelCRIa.Caption := FloatTostr( CRIs[0] );
    end;
end;

procedure TMainForm.RadioGroupGrabTypeClick(Sender: TObject);
begin
  if RadioGroupGrabType.ItemIndex = 0 then
    BtnStopGrab.Enabled := true
  else
    BtnStopGrab.Enabled := false;
end;

procedure TMainForm.RadioButton2Click(Sender: TObject);
begin
  if RadioButton2.Checked then
    begin
      BtnGetFrameData.Enabled := true;
      CheckBoxWaitFlag.Enabled := true;
      BtnInstallFrameHooker.Enabled := false;
    end
  else
    begin
      BtnGetFrameData.Enabled := false;
      CheckBoxWaitFlag.Enabled := false;
      BtnInstallFrameHooker.Enabled := true;
    end;
end;

procedure TMainForm.Timer1Timer(Sender: TObject);
begin
  bUpdateChart := true;
end;

end.
