// SSE SDK ExampleDlg.cpp : implementation file
//

#include "stdafx.h"
#include "SSE SDK Example.h"
#include "SSE SDK ExampleDlg.h"
#include "MT_Spectrometer_SDK.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif



extern CSSESDKExampleApp theApp;
int DeviceNum;
int DeviceID;
int SpectroID;
double RawData[3648];
double CalibData[3648];
double AbsInten[3648];

tFrameRecord* FramePtr;
//double **FramePtr;
//tFrameRecord* FramePtr;

/////////////////////////////////////////////////////////////////////////////
// CSSESDKExampleDlg dialog

CSSESDKExampleDlg::CSSESDKExampleDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSSESDKExampleDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSSESDKExampleDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSSESDKExampleDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSSESDKExampleDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CSSESDKExampleDlg, CDialog)
	//{{AFX_MSG_MAP(CSSESDKExampleDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(Btn_InitDevice, OnInitDevice)
	ON_BN_CLICKED(Btn_DeviceInfo, OnDeviceInfo)
	ON_BN_CLICKED(Btn_SetActiveFlag, OnSetActiveFlag)
	ON_BN_CLICKED(Btn_UnInitDevice, OnUnInitDevice)
	ON_BN_CLICKED(Btn_SetWorkMode, OnSetWorkMode)
	ON_BN_CLICKED(Btn_SetAvgNum, OnSetAvgNum)
	ON_BN_CLICKED(Btn_SetExpTime, OnSetExpTime)
	ON_BN_CLICKED(Btn_SetGPIOConfig, OnSetGPIOConfig)
	ON_BN_CLICKED(Btn_StartGrab, OnStartGrab)
	ON_BN_CLICKED(Btn_StopGrab, OnStopGrab)
	ON_BN_CLICKED(BtnGetWavCalib, OnBtnGetWavCalib)
	ON_BN_CLICKED(Btn_SetAutoDrkFlag, OnSetAutoDrkFlag)
	ON_BN_CLICKED(Btn_SetETCFlag, OnSetETCFlag)
	ON_BN_CLICKED(Btn_Get1931, OnGet1931)
	ON_BN_CLICKED(Btn_Get1976, OnGet1976)
	ON_BN_CLICKED(Btn_GetCCT, OnGetCCT)
	ON_BN_CLICKED(Btn_GetCRI, OnGetCRI)
	ON_BN_CLICKED(BtnGetFrame, OnBtnGetFrame)
	ON_BN_CLICKED(BtnSetDrkData, OnBtnSetDrkData)
	ON_BN_CLICKED(Btn_SetGPIOInOut, OnSetGPIOInOut)
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(Btn_InstallFrameCallback, &CSSESDKExampleDlg::OnBnClickedInstallframecallback)
END_MESSAGE_MAP()

void FrameCallBack(int Row, int Col, TFrameDataProperty* Attributes, void **FramePtr )
{
	tFrameRecord* AFramePtr;
	int i;
	double* tmpCCDptr;
	double* tmpCalibptr;
	double* tmpAbsptr;

	if (Attributes->CameraID == 1)
	{
		AFramePtr = (tFrameRecord *)(*FramePtr);
		tmpCCDptr = AFramePtr->RawData;
		tmpCalibptr = AFramePtr->CalibData;
		tmpAbsptr = AFramePtr->AbsInten;
		
		for (i=0; i<3648;i++)
		{
			RawData[i] = *tmpCCDptr++;
			CalibData[i] = *tmpCalibptr++;
			AbsInten[i] = *tmpAbsptr++;
		}
		((CSSESDKExampleDlg *)theApp.m_pMainWnd)->SetCallBackStatus(RawData[0], CalibData[0], AbsInten[0]);
		
	}
}

void CSSESDKExampleDlg::SetCallBackStatus(double Raw0, double Calib0, double AbsInten0)
{
	CString s;
	
	s.Format("%f", Raw0);
	SetDlgItemText( LabelRaw, s);
	
	s.Format("%f", Calib0);
	SetDlgItemText(LabelCalib, s);
	
	s.Format("%f", AbsInten0);
	SetDlgItemText(LabelAbsInten, s);
}

/////////////////////////////////////////////////////////////////////////////
// CSSESDKExampleDlg message handlers

BOOL CSSESDKExampleDlg::OnInitDialog()
{
	CString s;

	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
    DeviceNum = -1 ;
	DeviceID = 1;
	SpectroID = 1;

	CheckDlgButton( CheckActive, 1 );
    CheckDlgButton( RadioContinue, 1 );
    
	s.Format("%d", 1 );
	SetDlgItemText(EditAvgNum, s);

	s.Format("%d", 1000);
	SetDlgItemText(EditExpTime, s);    
	
	CheckDlgButton(RadioGrabOne, 1 );

	CheckDlgButton(RadioManualFrame, 1);
    
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CSSESDKExampleDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CSSESDKExampleDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CSSESDKExampleDlg::OnInitDevice() 
{
	// TODO: Add your control notification handler code here
	CString s;
	
	
	DeviceNum = MTSSE_InitDevice( 0 );
	s.Format("%d", DeviceNum);
    SetDlgItemText(LabelDeviceNum, s );
	SetDlgItemText(LabelStatus, "InitDevice:" + s );


}

void CSSESDKExampleDlg::OnDeviceInfo() 
{
	// TODO: Add your control notification handler code here
	char ModuleNo[32], SerialNo[32];

	if ( DeviceNum > 0 )
	{
	  MTSSE_GetDeviceModuleNoSerialNo( DeviceID, ModuleNo ,SerialNo);	  
	  SetDlgItemText( LabelDeviceInfo, CString( ModuleNo ) + "_" + CString( SerialNo) );
	}
}

void CSSESDKExampleDlg::OnSetActiveFlag() 
{
	// TODO: Add your control notification handler code here
	int ActiveFlag;
	int result ;
	CString s;

	if (DeviceNum > 0 )
	{
	  
	  ActiveFlag = IsDlgButtonChecked( CheckActive );
	
      result = MTSSE_SetDeviceActiveStatus( DeviceID, ActiveFlag );
	  s.Format("%d", result);
	  SetDlgItemText(LabelStatus, "SetActiveStatus: " + s );

	}
}

void CSSESDKExampleDlg::OnUnInitDevice() 
{
	// TODO: Add your control notification handler code here
	int result;
	CString s;
    result = MTSSE_UnInitDevice( );
	DeviceNum = 0;
	s.Format("%d", result);
	SetDlgItemText(LabelStatus,"UnInitDevice: " + s);

}

void CSSESDKExampleDlg::OnSetWorkMode() 
{
	int workMode; 
	int result;
	CString s;
	// TODO: Add your control notification handler code here
	if ( DeviceNum > 0 )
	{
      workMode = 0;

	  if ( IsDlgButtonChecked( RadioContinue ) == 1 )
        workMode = 0; 
	  else if ( IsDlgButtonChecked( RadioExtTrig ) == 1 )
	    workMode = 1;

	  result = MTSSE_SetDeviceWorkMode( DeviceID, workMode );
	  s.Format("%d", result);
 	  SetDlgItemText(LabelStatus, "SetWorkMode: " + s );	
	}
}

void CSSESDKExampleDlg::OnSetAvgNum() 
{
	int AvgNum ;
	int result;
	CString s;
	// TODO: Add your control notification handler code here
	if ( DeviceNum > 0)
	{
      AvgNum  = GetDlgItemInt(EditAvgNum);
      result = MTSSE_SetDeviceAverageFrameNum( DeviceID, AvgNum); 

	  s.Format("%d", result);
	  SetDlgItemText(LabelStatus, "MTSSE_SetDeviceAverageFrameNum: " + s );	
	}
}

void CSSESDKExampleDlg::OnSetExpTime() 
{
    int ExpTime;
	int result;
	CString s;
	// TODO: Add your control notification handler code here
	if (DeviceNum > 0)
	{
	  ExpTime = GetDlgItemInt(EditExpTime);
	  result = MTSSE_SetDeviceExposureTime(DeviceID, ExpTime);
	  s.Format("%d", result);
	  SetDlgItemText(LabelStatus, "MTSSE_SetDeviceExposureTime: " + s );		
	}
}

void CSSESDKExampleDlg::OnSetGPIOConfig() 
{
	int config;
	int result;
	CString s;
	// TODO: Add your control notification handler code here
	if (DeviceNum > 0)
	{
	  config = GetDlgItemInt(EditGPIOConfig);
      result = MTSSE_SetDeviceGPIOConfig(DeviceID, config);
	  s.Format("%d", result);
	  SetDlgItemText(LabelStatus, "MTSSE_SetDeviceGPIOConfig: " + s );		
	}
}

void CSSESDKExampleDlg::OnStartGrab() 
{
	int GrabType;
	int result;
	CString s;
	// TODO: Add your control notification handler code here
	if (DeviceNum > 0)
	{
	  GrabType = 1;

	  if (IsDlgButtonChecked(RadioGrabCont) == 1) 
	    GrabType = 0x8888;
	  else if( IsDlgButtonChecked(RadioGrabOne) == 1 )
		GrabType = 1;
	  result = MTSSE_StartFrameGrab( GrabType );

	  s.Format("%d", result);
	  SetDlgItemText(LabelStatus, "MTSSE_StartFrameGrab: " + s );		
	}
}

void CSSESDKExampleDlg::OnStopGrab() 
{
	int result;
	CString s;
	// TODO: Add your control notification handler code here
	if (DeviceNum > 0)
	{
	  result = MTSSE_StopFrameGrab();
	  s.Format("%d", result);
	  SetDlgItemText(LabelStatus, "MTSSE_StopFrameGrab: " + s );		
	}
}

void CSSESDKExampleDlg::OnBtnGetWavCalib() 
{
	double* WavCalibPtr;
	double WavCalib[8];
	int i;
	int result;
	CString s;
	// TODO: Add your control notification handler code here
	if (DeviceNum > 0) 
	{
	  result = MTSSE_GetDeviceSpectrometerWavCalPara(DeviceID, SpectroID, WavCalibPtr); 
	  if (result != -1)
	  {
		  for (i=0; i<8; i++)
		  {
			  WavCalib[i] = *WavCalibPtr++;
		  }

		  s.Format("%f", WavCalib[0]);
		  SetDlgItemText(LabelA0, "A0:" + s);

		  s.Format("%f", WavCalib[1]);
		  SetDlgItemText(LabelA1, "A1:" + s);

		  s.Format("%f", WavCalib[2]);
		  SetDlgItemText(LabelA2, "A2:" + s);

		  s.Format("%f", WavCalib[3]);
		  SetDlgItemText(LabelA3, "A3:" + s);

	  }
	  s.Format("%d", result);
	  SetDlgItemText(LabelStatus, "MTSSE_GetDeviceSpectrometerWavCalPara: " + s );		
	}
}

void CSSESDKExampleDlg::OnSetAutoDrkFlag() 
{
	int DrkFlag;
	int result;
	CString s;
	// TODO: Add your control notification handler code here
	if (DeviceNum > 0)
	{
	  DrkFlag = IsDlgButtonChecked(CheckAutoDrk);
	  result = MTSSE_SetDeviceSpectrometerAutoDarkStatus( DeviceID, SpectroID, DrkFlag);
	  s.Format("%d", result);
	  SetDlgItemText(LabelStatus, "MTSSE_SetDeviceSpectrometerAutoDarkStatus: " + s );		
	}
}

void CSSESDKExampleDlg::OnSetETCFlag() 
{
	int ETCFlag;
	int result;
	CString s;
	// TODO: Add your control notification handler code here
	if (DeviceNum > 0)
	{
	  ETCFlag = IsDlgButtonChecked(CheckETCStatus);
	  result = MTSSE_SetDeviceSpectrometerETCStatus(DeviceID, SpectroID, ETCFlag);
	  s.Format("%d", result);
	  SetDlgItemText(LabelStatus, "MTSSE_SetDeviceSpectrometerETCStatus: " + s );		
	}
}

void CSSESDKExampleDlg::OnGet1931() 
{
	double x, y;
	int result;
	CString s;

	// TODO: Add your control notification handler code here
	if (DeviceNum > 0)
	{
	  result = MTSSE_GetDeviceSpectrometerCIE1931Coords(DeviceID, SpectroID, AbsInten, x, y);
	  if (result != -1)
	  {
	    s.Format("%f%f", x, y);
		SetDlgItemText(Labelxy, s );
	  }
	  s.Format("%d", result);
	  SetDlgItemText(LabelStatus, "MTSSE_GetDeviceSpectrometerCIE1931Coords: " + s );		
	}
}

void CSSESDKExampleDlg::OnGet1976() 
{
	double u,v;
	int result;
	CString s;

	// TODO: Add your control notification handler code here
	if (DeviceNum > 0)
	{
	  result = MTSSE_GetDeviceSpectrometerCIE1976Coords(DeviceID, SpectroID, AbsInten, u, v);
	  if (result != -1)
	  {
	    s.Format("%f%f", u, v);
		SetDlgItemText(Labeluv, s );
	  }
	  s.Format("%d", result);
	  SetDlgItemText(LabelStatus, "MTSSE_GetDeviceSpectrometerCIE1931Coords: " + s );		
	}
		
}

void CSSESDKExampleDlg::OnGetCCT() 
{
	int CCT;
	int result;
	CString s;

	// TODO: Add your control notification handler code here
	if (DeviceNum > 0)
	{
	  result = MTSSE_GetDeviceSpectrometerCCT( DeviceID, SpectroID, AbsInten, CCT );
	  if (result != -1)
	  {
	    s.Format("%d", CCT);
		SetDlgItemText(LabelCCT, s );
	  }
	  s.Format("%d", result);
	  SetDlgItemText(LabelStatus, "MTSSE_GetDeviceSpectrometerCCT: " + s );		
	}	
}

void CSSESDKExampleDlg::OnGetCRI() 
{
	double CRIs[15];
	int result;
	CString s;
	// TODO: Add your control notification handler code here
	if (DeviceNum > 0)
	{
	  result = MTSSE_GetDeviceSpectrometerCRIs(DeviceID, SpectroID, AbsInten, CRIs);
	  if (result != -1)
	  {
	    s.Format("%f", CRIs[0]);
		SetDlgItemText(LabelCRIa, "CRIa:" + s );
	  }

	  s.Format("%d", result);
	  SetDlgItemText(LabelStatus, "MTSSE_GetDeviceSpectrometerCRIs: " + s );		
	}	
}

void CSSESDKExampleDlg::OnBtnGetFrame() 
{
	int i;
	double* tmpCCDptr;
	double* tmpCalibptr;
	double* tmpAbsptr;
	int result;
	CString s;
	TFrameDataProperty FrameProperty;
	
	// TODO: Add your control notification handler code here
	if (DeviceNum > 0) 
	{
	  //result = MTSSE_GetDeviceSpectrometerFrameData(DeviceID, SpectroID, 1, FramePtr);
		result = MTSSE_GetDeviceSpectrometerFrameDataProperty(DeviceID, SpectroID, 1,&FrameProperty,FramePtr);
	  if (result != -1)
	  {		 
		tmpCCDptr = FramePtr->RawData;
		tmpCalibptr = FramePtr->CalibData;
		tmpAbsptr = FramePtr->AbsInten;
		for (i=0; i<3648;i++)
		{
			RawData[i] = *tmpCCDptr++;
			CalibData[i] = *tmpCalibptr++;
			AbsInten[i] = *tmpAbsptr++;
		}
		s.Format("%f", RawData[0]);
		SetDlgItemText(LabelRaw, s ); 

		s.Format("%f", CalibData[0]);
		SetDlgItemText(LabelCalib, s ); 

		s.Format("%f", AbsInten[0]);
		SetDlgItemText(LabelAbsInten, s ); 
	  }
	  s.Format("%d", result);
	  SetDlgItemText(LabelStatus, "MTSSE_GetDeviceSpectrometerFrameData: " + s );		
	}
}

void CSSESDKExampleDlg::OnBtnSetDrkData() 
{
	int result;
	CString s;
	// TODO: Add your control notification handler code here
	if (DeviceNum > 0)
	{
	  result = MTSSE_SetDeviceSpectrometerDarkData(DeviceID, SpectroID, CalibData);
	  s.Format("%d", result);
	  SetDlgItemText(LabelStatus, "MTSSE_SetDeviceSpectrometerDarkData: " + s );		
	}
}

void CSSESDKExampleDlg::OnSetGPIOInOut() 
{
	unsigned char Input;
    int output;
	int result;
	CString s;
	// TODO: Add your control notification handler code here
	if (DeviceNum > 0)
	{
	  output = GetDlgItemInt(EditGPIOOut);
	  result = MTSSE_SetDeviceGPIOInOut(DeviceID, output, &Input );
      s.Format("%d", Input);
	  SetDlgItemText(LabelGPIOIn, s );
	  s.Format("%d", result);
	  SetDlgItemText(LabelStatus, "MTSSE_SetDeviceSpectrometerDarkData: " + s );		
	}

	
}

void CSSESDKExampleDlg::OnBnClickedInstallframecallback()
{
	// TODO: Add your control notification handler code here
	MTSSE_InstallDeviceFrameHooker(DeviceID,FrameCallBack); 
}
